<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>DS Batch Group Creation and Membership Utility</title>

<!-- 
 University of Illinois/NCSA Open Source License for groupcreate.php.

 Copyright (c) 2009 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/groupcreate
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 
-->

</head>
<body>
<h1>DS Batch Group Creation and Membership Utility</h1>

<?php 

if (@$_POST['ldap_id'] > "" ) {
	// newer systems support the _post system for posted variable
	// older ones http_post_vars so we test for both...
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$csv_data_file=$_POST['csv_data_file'];	
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) { 
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		// and this will come from our data file in the loop
		$csv_data_file=$HTTP_POST_VARS['csv_data_file'];	
	} else {
		// if we haven't got any ldap id set go to the authentication form
		DisplayForm();
		closedocument();
		exit;
	}
}

echo "<p>Connection to LDAP server";

// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection
// So we start by connecting to LDAP
$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded</p>\n<p>";
	// we have now made an LDAP connection
} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}

readinfile ($csv_data_file);
//this puts the csv in the array $arrbrecords
// we need to page through it
foreach ($arrbrecords as $c) {
	//echo "<p> each rec: " . $c[0]." - ". $c[1]." - " . $c[2] . "</p>";
	// in the csv field 0 is cn, field 1 is context, 2 is description, 3 on are group members...
	$group_naming_attrs['cn'] = $c[0];
	// convert OU from Netware Syntax to LDAP
    $group_ou = EdirtoLdap( $c[1]);
    // and create the full DN
    $group_dn = "cn=" . $group_naming_attrs['cn'] . "," . $group_ou ;
	$group_naming_attrs['description'] = $c[2];
    $group_naming_attrs['objectClass'] = "groupOfNames";
	// first we find if the group exists: if it does that's fine...
	// so search for it in its DN, using its CN
	// if the system has got multiple groups with the same CN under the context
	// then it will return all of them which is a potential glitch, but serve 'em right!
    $sr = ldap_search($ds, $group_ou, "cn=" . $group_naming_attrs['cn']);
    $entry_count = ldap_count_entries($ds, $sr);
    //echo "<p> Group search found $entry_count groups</p>";
    // this is a flag to see if we have one and only one group with the right CN
    $group_present = FALSE; 
    // if the group doesn't exist 
    if($entry_count < 1) {
    	// we try and create it
		if (ldap_add($ds, $group_dn, $group_naming_attrs)) {
	  		echo "Creation of group $group_dn Succeeded.<br>\n";
	  		$group_present = TRUE;  
		}else{
			echo "Creation of group $group_dn failed.<br>\n";
    	}
    } elseif ($entry_count > 1) { 
    	echo "Multiple Groups named $group_dn exist under context $group_ou.<br>\n";
    } else {
      	$group_present = TRUE;  
    }
	if ($group_present) {
	    //here we do all the group memberships...
		// either the group existed or we created it...
		// variable to store number of users processed...
		$user_Count=0;
	    $arr_count=count($c);
	    for($r=3; $r < $arr_count; $r++) {
		    // having done that we need to do the group memberships and security equals (do all 4)
		    // for each remaining item in $c
	    	$user_cn = $c[$r];
	    	// find matching object for user and get user dn
	    	if(strlen($user_cn)>0) {
	    		// flag for user present...
				$user_found=FALSE;
	    		$sr = ldap_search($ds, $working_ou, "cn=" . $user_cn);
	    		// Count the number of entries returned and check for errors.
				//echo "<p>Search for $ds $working_ou $user_cn </p>\n";
				$entry_count = ldap_count_entries($ds, $sr);
				//echo "<p>Search completed, ".$entry_count . " entries found<br />\n";
				// we must have exactly one entry returned to be happy we are editing the right
				// object in the DS< else we must quit
				if($entry_count >1) {
					echo "$entry_count objects were found that match user $user_cn";
					echo " under OU $working_ou and were <b>skipped</b>.<br>\n";
					$entry_info=ldap_get_entries($ds, $sr);
					foreach ($entry_info as $entry_data) {
						if (strlen($entry_data["dn"])>0) {
							echo "&nbsp;&nbsp;&nbsp;&nbsp;" . $entry_data["dn"] . "<br>\n";
						}
					}
				} else {
					if($entry_count <1) {
						echo "No objects were found that match $user_cn under " . $working_ou ;
						echo ". This file entry was <b>skipped</b>.<br />\n";
					//continue;
					 } else {
						// we get the entries for this one result (!)
						$entry_info=ldap_get_entries($ds, $sr);
						$user_dn = $entry_info[0]["dn"];
						$user_found=TRUE;
					}
				}
				if ($user_found){
		    		//for group object
			 		$group_info['member'][] = $user_dn; // User's DN is added to group's 'member' array
			     	$group_info['equivalentToMe'][] = $user_dn; // User's DN is added to group's 'equivalentToMe' array
				    // set member
			    	// set equivalentToMe
			    	// for user object 
			    	// set groupMembership
			    	// set securityEquals
			 		$user_info['groupMembership']= $group_dn; // User's DN is added to group's 'member' array
			     	$user_info['securityEquals'] = $group_dn; // User's DN is added to group's 'equivalentToMe' array
			    	if (ldap_mod_add($ds,$user_dn,$user_info)){
			    		//echo "<p>Ldap User Mod succeeded</p>";
			    		$usercount++;
			    	} else {
		        		echo "Association of group $group_dn failed on user $user_dn.<br>\n";
			    	}
				}
			    $user_info="";
	    	}
		}
		if (ldap_mod_add($ds,$group_dn,$group_info)) {
	    	echo "$user_count associations added to group $group_dn<br>\n";
		}else{
	        echo "User association failed on group $group_dn.<br>\n";
		}
	}
	$group_info="";
}

closedocument();
exit;
    
function ReadinFile( $fname ) {
	//global arrey for output...
	global $arrbrecords;
	$arrholder = array();
	$arrptr = 0;
	//First we open the csv file
	$handle = @fopen($fname, "r");
	if ($handle== false) {
		echo "</p><h2>Data File Open Failed</h2>\n";
		echo "<p>There are a number of reasons why this might have happened. The file might genuinely not exists, or perhaps its stored \n";
		echo "on an area of the server where the script does not have rights to open files.</p>\n";
		echo "<p>Use back to go back to the form and correct the path opr move the file to somewhere the script ";
		echo "can definitely access it. The directory where the script is stored should always work.</p>\n";
		closedocument();
		exit;
	} 	

	$arrptr=0;
	while (!feof($handle)) {
		$arr_buffer = fgetcsv($handle, 4096);
		// we always test and that way handle blank records in teh file...
		// also we need to allow for their not being enough fields...
		$numrecs = count($arr_buffer);
		if ($numrecs > 4) {
			// then we have a potentially good line with four plus records and continue processing it in here
			// so we look at first two records and see if its got something in it...
			if (strlen(trim($arr_buffer[0])) < 2) { 
				continue;
			}
			if (strlen(trim($arr_buffer[1])) < 2) { 
				continue;
			}
			// OK we ve done crude validation and reckon we ve got some records
			// now we put data in the array
			for ($i = 0; $i < $numrecs; $i++) {
 			   //echo $i;
 			   $arrbrecords[$arrptr][$i] = trim($arr_buffer[$i]);
			}
		} else {
			// we got here because we didn t have 2 records in teh line of CSV
			// so we do nothing and continue
		}
		// and increment the array pointer
		$arrptr++;
	}
	// now close the file
	if (fclose($handle)) {
		//echo "\nFile Closed successfully<br />\n";
	} else {
		echo "\nFile Close Failed: contact Application Support.<br />\n";
	}
}

function EdirtoLdap($DN) {
	//echo "<pre>Edirtoldap function</pre>";
	// OK here we have a Netware format Context
	// ie fred.bill.adrian.org
	// we want to convert it to LDAP format eg
	// cn=fred,ou=bill,ou=adrian,o=org
	$last = strrchr($DN, ".");
	$DN = str_replace($last,",O=".substr($last,1),$DN);
	$DN = str_replace(".",",OU=",$DN);
	return "OU=" . $DN;
}

function DisplayForm() {
// this produces the form to fill in when there's not a ldap _id in the post vars. 
$form_body = <<<HTMLFORM
<form method="POST" action="dsgrpcrt.php" enctype="x-www-form-urlencoded">
<table class="main" cellpadding="2" cellspacing="2">
	<tr>
		<td class="maintdpos">LDAP Admin User ID:</td>
		<td class="maintdpos"><input type="text" name="ldap_id" size="30"
			maxlength="80"></td>
	</tr>
	<tr>
		<td class="maintdpos">LDAP Password:</td>
		<td class="maintdpos"><input type="password" name="ldap_pw"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td class="maintdpos">LDAP Server:</td>
		<td class="maintdpos"><input type="text" name="ldap_server"
			value="sccnthfa5.surreycc.gov.uk" size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
	<tr>
		<td class="maintdpos">Working OU/Context:</td>
		<td class="maintdpos"><input type="text" name="working_ou"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td class="maintdpos">CSV Data File:</td>
		<td class="maintdpos"><input type="text" name="csv_data_file"
			size="30" maxlength="40"></td>
	</tr>

	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>

	<tr>
		<td class="maintdpos"><input type="submit" value="Post Details"></td>
		<td class="maintdpos"><input type="reset" value="Clear Form"></td>
	</tr>
</table>
</center>
<h3>Notes and Help</h3>
<p>LDAP Admin user id must be in typeful LDAP format ie <code>cn=adminuser,o=organisation</code>.
The delimiters must be commas and not full stops.
<p>
<p>LDAP server. The best servers to use are SCCNTHFA5 or SCCNTHFA6,
depending on whether you are working in the NTH (5) or STH (6) areas of
the NDS Tree.</p>
<p>Working OU/Context must also be in typeful; LDAP format, so <code>ou=dept,ou=building,ou=town,o=organisation</code>
This controls how far down the tree the utility searches for group
members. The higher up then the faster it runs, the lower down the more
OUS can be processed. But you should not be creating group memberships
that go outside the building container.</p>
<p>CSV data file can be a path local to the server where you are
running the script, and this is preferred. It may be possible to use an
HTTP or ftp command line to connect to a file on a remote server, but
the file would need to be available to anonymous access. There will
probably also be limitations on where on the file can be stored on the
server. The safest and easiest place to put it is in the directory where
the script is running. For instance if you run the app from url
http://inetdev5/cor/imt/imtapps/dsbedit then w:\cor\imt\imtapps\dsbedit
is the folder where the script runs from, so storing the data file in
this folder would mean that you wouldn't need to use a path, just the
file name.</p>
<p>The format for the data file is as follows:-</p>
<pre>Group CN,Group OU,Group Description, Member CN1, Member CN2, etc...</pre>
<p>For example:</p>
<pre>Widgets-Team,dept.site.organisation,billg,lellison,sjobs
Gurus-Team,dept.site.organisation,ghopper,linus
All-Dept,dept.site.organisation,ghopper,linus,billg,lellison,sjobs</pre>
<p>Note especially that OUs are in Netware format, delimited by a
stop, not LDAP format, delimited by commas.</p>
<p>groupcreate.php is &copy; Surrey County Council 2010.</p>

HTMLFORM;
echo $form_body;
}
?>
</body>
</html>